{==============================================================================}
{ TBinClipboard Demo (C) S. Tkachenko (svt@system.unicor.ac.ru)                }
{ http://www.crosswinds.net/~svtpro/                                           }
{==============================================================================}
{ This program demonstrate how to copy/paste your data to/from Clipboard       }
{ in your format.                                                              }
{ This demo copies/pastes 3 values: ScrollBar.Min, ScrollBar.Max,              }
{ ScrollBar.Position as "ScrollBar Position" format                            }
{==============================================================================}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Clipbrd, BinClipboard, StdCtrls, ExtCtrls, ShellAPI;

type
  TForm1 = class(TForm)
    BinClipboard: TBinClipboard;
    btnCopy: TButton;
    btnPaste: TButton;
    ScrollBar: TScrollBar;
    btnExit: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    lblMail: TLabel;
    lblHomepage: TLabel;
    procedure btnExitClick(Sender: TObject);
    procedure lblMailClick(Sender: TObject);
    procedure lblHomepageClick(Sender: TObject);
    procedure btnCopyClick(Sender: TObject);
    procedure btnPasteClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnCopyClick(Sender: TObject);
var Stream: TMemoryStream;
    v: Integer;
begin
  // Copying Min, Max and Position of ScrollBar as "ScrollBar Position"
  // Clipboard format...
  Stream := TMemoryStream.Create;
  v := ScrollBar.Min;
  Stream.WriteBuffer(v, SizeOf(v));
  v := ScrollBar.Max;
  Stream.WriteBuffer(v, SizeOf(v));
  v := ScrollBar.Position;
  Stream.WriteBuffer(v, SizeOf(v));
  Clipboard.Clear;
  BinClipboard.Copy(Stream);
  Stream.Free;
end;

procedure TForm1.btnPasteClick(Sender: TObject);
var Stream: TMemoryStream;
    v: Integer;
begin
  // Pasting Min, Max and Position of ScrollBar as "ScrollBar Position"
  // Clipboard format...
  Stream := TMemoryStream.Create;
  if BinClipboard.Paste(Stream) then begin
    Stream.ReadBuffer(v, SizeOf(v));
    ScrollBar.Min := v;
    Stream.ReadBuffer(v, SizeOf(v));
    ScrollBar.Max := v;
    Stream.ReadBuffer(v, SizeOf(v));
    ScrollBar.Position := v;
    end
  else
    Application.MessageBox('Clipboard does not contains "ScrollBar Position" format!',
                           'Can not paste', MB_OK or MB_ICONEXCLAMATION);
  Stream.Free;
end;

procedure TForm1.btnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.lblMailClick(Sender: TObject);
begin
  ShellExecute(Application.Handle, 'open', 'mailto:svt@system.unicor.ac.ru?subject=From TBinClipboard Demo', nil, nil, SW_NORMAL);
end;

procedure TForm1.lblHomepageClick(Sender: TObject);
begin
  ShellExecute(Application.Handle, 'open', 'http://www.crosswinds.net/~svtpro/', nil, nil, SW_NORMAL);
end;

end.
